(** Time-stamp: <modified the 28/08/2008 (at 17:01) by Erwan Jahier> *)

(** nb: compiling = type checking + constant evaluation *)


(** A lazy compiler is an internal structure that contains tables
    storing compiled entities (types, const, node). At the beginning
    (on creation), it only contains empty tables. But then, one when
    ask for a type, a const, or a node, the tables are filled in.
*)
type t

(* Create a lazy compiler. *)
val create : SyntaxTab.t -> t


(** Compiles one node *)
val node_check : t -> Eff.node_key -> Lxm.t -> Eff.node_exp


(* compile all items *)
val compile_all : t -> unit
