(** Time-stamp: <modified the 29/08/2008 (at 16:29) by Erwan Jahier> *)


(** Split the equations of a node into several ones, in such a way
    that there is only one operator per equation. The rational for
    doing that is to make the clock checking trivial in the lic code
    (indeed, nested node call makes it tricky).

    We also split tuples. For example, the equation:

        (a, b, c) =  (1, 2, 3)  -> titi(x); 

    is splitted into 4 equations:

       a = 1 -> _v1;
       b = 2 -> _v2;
       c = 3 -> _v3;
       (_v1, _v2, _v3) = titi(x);

*)
val node : Eff.node_exp -> Eff.node_exp
