(** Time-stamp: <modified the 11/09/2008 (at 14:08) by Erwan Jahier> *)


(* XXX use Map.t 

   We have Two kind of substitutions. 

   - One is used to deal with the clock name binding, to relate node
   parameters and node arguments.

   - The other one is used to deal with polymorphic clock
   variables. Indeed, constant clock is intrinsically
   polymorphic. Hence, when clocking a contant (e.g., "42"), we
   return the clock_info Ci_var i, where i is a fresh
   integer. Afterwards, when encoutering an expression such as
   "42+x", where we know the clock of x (clk_x), we produce the
   substitution (i,clk_x).

   XXX Shouldn't I merge the 2 kind of substitutions ?  That would
   mean I need to invent a fake var_info_eff, but it would make the
   whole more homogeous.

   XXX Make it abstract?
*)
type subst = (Ident.t * Ident.t) list  * (int * Eff.clock) list

val empty_subst : subst


val apply_subst:subst -> Eff.id_clock -> Eff.id_clock

(* only apply the part of the subst that deals with clock var *)
val apply_subst2:subst -> Eff.id_clock -> Eff.id_clock

(** Raises an error is the 2 Eff.id_clock are not unifiable *)
val f : Lxm.t -> subst -> Eff.id_clock -> Eff.id_clock -> subst
val list : Lxm.t -> Eff.id_clock list -> subst -> Eff.id_clock * subst


(* Stuff to generated fresh var clocks  
   XXX bad place, bad name
*)
val reset_var_type : unit -> unit
val get_constant_clock : unit -> Eff.clock
val get_var_type : unit -> int
